#include "fundtypes.h"

#define	max_samples 16384
#define	max_chars 1000
#define	t_divisions	10
#define	v_divisions	8
//actions:
enum scope_acquisition_types {acq_single, acq_auto, acq_triggered, acq_stop};
enum scope_commands {c_init, c_acquire, c_replay, c_check, c_update, c_close, c_idle, c_function, c_get_frame, c_finish};
enum scope_status {c_runtime_closed, c_closed, c_open,  c_fault, c_fault_closed};
enum scope_trigger_channel { trig_chan_a, trig_chan_b, trig_ext, trig_dig};
enum scope_interface {if_usb, if_ethernet_find_ip, if_ethernet_first_ip, if_ethernet_find_sernum};

/* = Sample Oscilloscope Include File ===================================== */
uInt16	call_cscope_control_driver(uInt16 command);
int32 	scope_init (void);
int32	cscope_interface(int32 unit_index, uInt16 Intf_source, uInt32 TCP_adr);
int32 	scope_close (void);
int32 	scope_config (void);
int32	scope_acquire (void);
int32	get_CAU_status(void);
float64 get_function(uInt16 cmd_value, float64 cmd_parameter);
int32 	scope_read_waveform (float a_waveform[max_samples], float b_waveform[max_samples], int32 *num_samples,  float64 *delta_t, float64 *t_zero);
int32 	check_for_samples(void);
void 	update_values(float64 a_div, float64 b_div, float64 t_div, int32 number_of_points,
					float64 freq, float64 sigvolts, float64 trigvolts, int32 trig_chan,
					uInt16 trigger_action, uInt32 dig_pattern);
uInt32 string_to_IP(char * ip_str);		//converts a string to a U32 IP address
