#include "extcode.h"
#pragma pack(push)
#pragma pack(1)

#ifdef __cplusplus
extern "C" {
#endif
typedef struct {
	unsigned short AcquireMode;
	unsigned short AcquisitionMode;
	unsigned short Acquirer;
	unsigned short TransferChans;
	double AMaxScale;
	double AMinScale;
	double BMaxScale;
	double BMinScale;
	unsigned short AProbe;
	unsigned short BProbe;
	unsigned short ACoupling;
	unsigned short BCoupling;
	unsigned short ABandwidth;
	unsigned short BBandwidth;
	unsigned int TriggerSource;
	double TriggerAmplitude;
	double ATriggerAmplitude;
	double BTriggerAmplitude;
	unsigned short TriggerFilter;
	LVBoolean TrigSlope;
	double TriggerHoldoff;
	LVBoolean DigPatternRqd;
	unsigned int DigPattern;
	double ExtTrigThreshold;
	double DigInputThreshold;
	double StartTime;
	double StopTime;
	double SampleInterval;
	unsigned short Port;
	short NumDivisions;
	short NumSeqFrames;
	int NumBuffers;
	double SigGenFreq;
	double SigGenAmp;
	double SigGenOffset;
	unsigned short SigGenWaveform;
	unsigned short SigGenSweep;
	unsigned short SigGenFunc;
	double SigGenFreq2;
	double SigGenPhase;
	unsigned short Trig2Function;
	double MinTriggerPeriod;
	double MaxTriggerPeriod;
	unsigned int TriggerCount;
	LVBoolean Trig2Slope;
	unsigned int Trig2SourceChan;
	double Trig2Level;
	LVBoolean DigPattern2Rqd;
	unsigned int DigPattern2;
	unsigned short Trigger2Source;
	int WaveformAverages;
	int ValueChanged;
	double FreqSpan;
	double FreqRes;
	double Duration;
	double Resolution;
	unsigned char LinkPort;
	unsigned char ExtSampleClock;
	LVBoolean FSpare2;
	LVBoolean FSpare3;
	LVBoolean FSpare4;
	unsigned short SamplerResolution;
	unsigned short IntfSource;
	unsigned short UpdateRate;
	unsigned short TransferSize;
	double SigGenFreqStep;
	unsigned int TCPAdr;
	unsigned int TCPPort;
	unsigned int CAUSerNumHi;
	unsigned int CAUSerNumLo;
	double FunctionNumber;
	double FunctionParameter;
	double FunctionResult;
	unsigned int LinkStart;
	unsigned int LinkTimebase;
	unsigned int LinkTimer;
	unsigned int LinkSetup;
	double Spare1;
	double Spare2;
	double Spare3;
	double Spare4;
	} TD1;

typedef struct {
	LVBoolean status;
	int code;
	LStrHandle source;
	} TD2;


void __stdcall CscopeControlDriver(int AcquisitionUnit,
	unsigned short Command, double ReplayStartTime, double ReplayStopTime,
	int SamplesInReplay, int FrameNumber, TD1 *AcquireDefinition,
	LVBoolean *GotSamples, double *T0, double *dT, unsigned int *NumSamples,
	unsigned int *NumFrames, float ChanAData[], int ChanAAllocSpace,
	float ChanBData[], int ChanBAllocSpace, unsigned short DigitalInputData[],
	int DigInpAllocSpace, unsigned short *CAUStatus, TD2 *errorOut);
void __stdcall CscopeFunction(int AcquisitionUnit,
	unsigned short FunctionCommand, double Parameter,
	unsigned char LinkDataSend[], int LinkDataSendAllocSpace,
	double *FunctionResult, double *ResultA, double *ResultB,
	unsigned char LinkDataReceived[], int LinkDataReceivedAllocSpace,
	TD2 *errorOut);
void __stdcall CscopeSpectrum(int AcquisitionUnit,
	unsigned short SpectrumType, unsigned short FFTWindow, LVBoolean *dBOn,
	LVBoolean *DegreesOn, LVBoolean *UnwrapPhase, double *dF, int *NumFreqBins,
	double ChanAAmpGain[], int ChanAAmpGainAllocSpace, double ChanBAmpPhase[],
	int ChanBAmpPhaseAllocSpace, double ChanAImPhase[],
	int ChanAImPhaseAllocSpace, double ChanBImPhase[],
	int ChanBImPhaseAllocSpace, TD2 *errorOut);

int __cdecl LVDLLStatus(char *errStr, int errStrLen, void *module);

#ifdef __cplusplus
} // extern "C"
#endif

#pragma pack(pop)

