unit Cscope_control_driver;

interface
uses

  Windows,SysUtils;


type char2 = array[0..100000] of byte;
     pchar2 = ^char2;
type testt = array[0..100000] of byte;
     ptestt = ^testt;

  {$ALIGN OFF}
type
  Acquire_record =packed record
    AcquireMode: Word;
    AcquisitionMode: Word;
    Acquirer: Word;
    TransferChans: Word;
    AMaxScale: Double;
    AMinScale: Double;
    BMaxScale: Double;
    BMinScale: Double;
    AProbe: Word;
    BProbe: Word;
    ACoupling: Word;
    BCoupling: Word;
    ABandwidth: Word;
    BBandwidth: Word;
    TriggerSource: LongInt;
    TriggerAmplitude: Double;
    ATriggerAmplitude: Double;
    BTriggerAmplitude: Double;
    TriggerFilter: Word;
    TrigSlope: byte;
    TriggerHoldoff: Double;
    DigPatternRqd: byte;
    DigPattern: LongInt;
    ExtTrigThreshold: Double;
    DigInputThreshold: Double;
    StartTime: Double;
    StopTime: Double;
    PreTrigTime: Double;
    Port: Word;
    NumDivisions: SmallInt;
    NumSeqFrames: SmallInt;
    NumBuffers: LongInt;
    SigGenFreq: Double;
    SigGenAmp: Double;
    SigGenOffset: Double;
    SigGenWaveform: Word;
    SigGenSweep: Word;
    SigGenFunc: Word;
    SigGenFreq2: Double;
    SigGenPhase: Double;
    Trig2Function: Word;
    MinTriggerPeriod: Double;
    MaxTriggerPeriod: Double;
    TriggerCount: LongInt;
    Trig2Slope: byte;
    Trig2SourceChan: LongInt;
    Trig2Level: Double;
    DigPattern2Rqd: byte;
    DigPattern2: LongInt;
    Trigger2Source: Word;
    WaveformAverages: LongInt;
    ValueChanged: LongInt;
    FreqSpan: Double;
    FreqRes: Double;
    Duration: Double;
    Resolution: Double;
	UnitsAreLinked :byte;
	ExtSampleClock: byte;
	FSpare2 : byte;
	FSpare3 :byte;
	FSpare4 :byte;
	SamplerResolution: Word;
	IntfSource :Word;
	UpdateRate : Word;
	TransferSize :Word;
	SigGenFreqStep: Double;
	TCPAdr : LongWord;
	TCPPort :  LongWord;
   CAUSerNumHi: LongInt;
	CAUSerNumLo :LongInt;
	FunctionNumber : double ;
	FunctionParameter : double;
	FunctionResult : double;
	LinkStart : LongWord;
	LinkTimebase : LongWord;
	LinkTimer : LongWord;
	LinkSetup : LongWord;
	Spare1 : double;
	Spare2 : double;
	Spare3 : double;
	Spare4 : double;

  end {Acquire_record};

  type pAcquire_record = ^Acquire_record;

type
  Error_record =packed record
    status: byte;
    code: LongInt;
    source: pchar2;
  end {Error_record};

  type pError_record = ^Error_record;



procedure  CscopeControlDriver (AcquisitionUnit : LongInt;
								  Command: Word;
                                 ReplayStartTime: Double;
                                 ReplayStopTime: Double;
                                 SamplesInReplay: LongInt;
                                 FrameNumber:	LongInt;
                                  AcquireDefinition: pAcquire_record;

                                  GotSamples: pbyte;
                                  T0: pDouble;
                                  dT: pDouble;
                                  NumSamples: pLongInt;
                                  NumFrames: pLongInt;
                                  ChanAData: pSingle;
                                 ChanAAllocSpace: longint;
                                 ChanBData: pSingle;
                                 ChanBAllocSpace: longint;
                                 DigitalInputData: pword;
                                 DigInpAllocSpace: longint;
                                 CAUStatus :pword;
                                   errorOut: pError_record


                                 )
            cdecl stdcall  ;


procedure CscopeFunction(	AcquisitionUnit :LongInt;
								FunctionCommand	:	Word;
                Parameter :Double;
                LinkDataSend	:	PByte;
								LinkDataSendAllocSpace: longint;
                               FunctionResult : PDouble;
								ResultA : PDouble;
								ResultB: PDouble;
                               LinkDataReceived	:	PByte;
                               LinkDataReceivedAllocSpace: longint;
                               errorOut : pError_record)
            cdecl stdcall  ;


 function  LVDLLStatus(errStr: PChar;
                        errStrLen: Integer;
                        module: Pointer): LongInt   cdecl;



implementation


procedure  CscopeControlDriver; external 'Cscope Control Driver.dll' name 'CscopeControlDriver';

procedure  CscopeFunction; external 'Cscope Control Driver.dll' name 'CscopeFunction';

function  LVDLLStatus; external 'Cscope Control Driver.dll' name 'LVDLLStatus';

var  DLLHandle:  THandle ;


initialization
    DLLHandle := LoadLibrary('Cscope Control Driver.dll') ;
    if (DLLHandle = 0) then begin
        raise EAbstractError.CreateFmt('Error Loading %s (Error Code %x)', ['Cscope Control Driver.dll', GetLastError]) ;
    end ;



end.
