#include "extcode.h"
#pragma pack(push)
#pragma pack(1)

#ifdef __cplusplus
extern "C" {
#endif
typedef struct {
	uint16_t AcquireMode;
	uint16_t AcquisitionMode;
	uint16_t Acquirer;
	uint16_t TransferChans;
	double AMaxScale;
	double AMinScale;
	double BMaxScale;
	double BMinScale;
	uint16_t AProbe;
	uint16_t BProbe;
	uint16_t ACoupling;
	uint16_t BCoupling;
	uint16_t ABandwidth;
	uint16_t BBandwidth;
	uint32_t TriggerSource;
	double TriggerAmplitude;
	double ATriggerAmplitude;
	double BTriggerAmplitude;
	uint16_t TriggerFilter;
	LVBoolean TrigSlope;
	double TriggerHoldoff;
	LVBoolean DigPatternRqd;
	uint32_t DigPattern;
	double ExtTrigThreshold;
	double DigInputThreshold;
	double StartTime;
	double StopTime;
	double PreTrigTime;
	uint16_t Port;
	int16_t NumDivisions;
	int16_t NumSeqFrames;
	int32_t NumBuffers;
	double SigGenFreq;
	double SigGenAmp;
	double SigGenOffset;
	uint16_t SigGenWaveform;
	uint16_t SigGenSweep;
	uint16_t SigGenFunc;
	double SigGenFreq2;
	double SigGenPhase;
	uint16_t Trig2Function;
	double MinTriggerPeriod;
	double MaxTriggerPeriod;
	uint32_t TriggerCount;
	LVBoolean Trig2Slope;
	uint32_t Trig2SourceChan;
	double Trig2Level;
	LVBoolean DigPattern2Rqd;
	uint32_t DigPattern2;
	uint16_t Trigger2Source;
	int32_t WaveformAverages;
	int32_t ValueChanged;
	double FreqSpan;
	double FreqRes;
	double Duration;
	double Resolution;
	uint8_t LinkPort;
	LVBoolean ExtSampleClock;
	LVBoolean FSpare2;
	LVBoolean FSpare3;
	LVBoolean FSpare4;
	uint16_t SamplerResolution;
	uint16_t IntfSource;
	uint16_t UpdateRate;
	uint16_t TransferSize;
	double SigGenFreqStep;
	uint32_t TCPAdr;
	uint32_t TCPPort;
	uint32_t CAUSerNumHi;
	uint32_t CAUSerNumLo;
	double FunctionNumber;
	double FunctionParameter;
	double FunctionResult;
	uint32_t LinkStart;
	uint32_t LinkTimebase;
	uint32_t LinkTimer;
	uint32_t LinkSetup;
	double Spare1;
	double Spare2;
	double Spare3;
	double Spare4;
	} TD1;

typedef struct {
	LVBoolean status;
	int32_t code;
	LStrHandle source;
	} TD2;


void __stdcall CscopeControlDriver(int32_t AcquisitionUnit, uint16_t Command, 
	double ReplayStartTime, double ReplayStopTime, int32_t SamplesInReplay, 
	int32_t FrameNumber, TD1 *AcquireDefinition, LVBoolean *GotSamples, 
	double *T0, double *dT, uint32_t *NumSamples, uint32_t *NumFrames, 
	float ChanAData[], int32_t ChanAAllocSpace, float ChanBData[], 
	int32_t ChanBAllocSpace, uint16_t DigitalInputData[], 
	int32_t DigInpAllocSpace, uint16_t *CAUStatus, TD2 *errorOut);
void __stdcall CscopeFunction(int32_t AcquisitionUnit, 
	uint16_t FunctionCommand, double Parameter, uint8_t LinkDataSend[], 
	int32_t LinkDataSendAllocSpace, double *FunctionResult, 
	uint8_t LinkDataReceived[], int32_t LinkDataReceivedAllocSpace, 
	TD2 *errorOut);

long __cdecl LVDLLStatus(char *errStr, int errStrLen, void *module);

#ifdef __cplusplus
} // extern "C"
#endif

#pragma pack(pop)

