Imports System
Imports System.Runtime.InteropServices

    <StructLayout(LayoutKind.Sequential, Pack := 1)> _
    Public Structure CSCOPE_ACQUIRE
    
        Public AcquireMode As system.UInt16
        Public AcquisitionMode As system.UInt16
        Public Acquirer As system.UInt16
        Public TransferChans As system.UInt16
        Public AMaxScale As Double
        Public AMinScale As Double
        Public BMaxScale As Double
        Public BMinScale As Double
        Public AProbe As system.UInt16
        Public BProbe As system.UInt16
        Public ACoupling As system.UInt16
        Public BCoupling As system.UInt16
        Public ABandwidth As system.UInt16
        Public BBandwidth As system.UInt16
        Public TriggerSource As system.UInt32
        Public TriggerAmplitude As Double
        Public ATriggerAmplitude As Double
        Public BTriggerAmplitude As Double
        Public TriggerFilter As system.UInt16
        Public TrigSlope As Byte
        Public TriggerHoldoff As Double
        Public DigPatternRqd As Byte
        Public DigPattern As system.UInt32
        Public ExtTrigThreshold As Double
        Public DigInputThreshold As Double
        Public StartTime As Double
        Public StopTime As Double
    Public SampleInterval As Double
        Public Port As system.UInt16
        Public NumDivisions As system.Int16
        Public NumSeqFrames As system.Int16
        Public NumBuffers As system.Int32
        Public SigGenFreq As Double
        Public SigGenAmp As Double
        Public SigGenOffset As Double
        Public SigGenWaveform As system.UInt16
        Public SigGenSweep As system.UInt16
        Public SigGenFunc As system.UInt16
        Public SigGenFreq2 As Double
        Public SigGenPhase As Double
        Public Trig2Function As system.UInt16
        Public MinTriggerPeriod As Double
        Public MaxTriggerPeriod As Double
        Public TriggerCount As system.UInt32
        Public Trig2Slope As Byte
        Public Trig2SourceChan As system.UInt32
        Public Trig2Level As Double
        Public DigPattern2Rqd As Byte
        Public DigPattern2 As system.UInt32
        Public Trigger2Source As system.UInt16
        Public WaveformAverages As system.Int32
        Public ValueChanged As system.Int32
        Public FreqSpan As Double
        Public FreqRes As Double
        Public Duration As Double
        Public Resolution As Double
        Public UnitsAreLinked As Byte
        Public ExtSampleClock As Byte
        Public FSpare2 As Byte
        Public FSpare3 As Byte
        Public FSpare4 As Byte
        Public SamplerResolution As system.UInt16
        Public IntfSource As system.UInt16
        Public UpdateRate As system.UInt16
        Public TransferSize As system.UInt16
        Public SigGenFreqStep As Double
        Public TCPAdr As system.UInt32
        Public TCPPort As system.UInt32
    Public CAUSerNumHi As System.UInt32
    Public CAUSerNumLo As System.UInt32
    Public FunctionNumber As Double
    Public FunctionParameter As Double
    Public FunctionResult As Double
    Public LinkStart As System.UInt32
    Public LinkTimebase As System.UInt32
    Public LinkTimer As System.UInt32
    Public LinkSetup As System.UInt32
    Public Spare1 As Double
    Public Spare2 As Double
    Public Spare3 As Double
    Public Spare4 As Double

    End Structure

    <StructLayout(LayoutKind.Sequential , Pack := 1)> _
    Public Structure CSCOPE_ERROR

        Public status As Byte
        Public code As system.Int32
        Public source As system.Int32 'this is normally a handle, but we aren't using it
    End Structure


Public Class Cscope_control
    <DllImport("Cscope Control Driver.dll", CharSet:=CharSet.Auto)> _
    Public Shared Sub CscopeControlDriver(ByVal AcquisitionUnit As System.Int32, ByVal Command As System.UInt16, _
        ByVal ReplayStartTime As Double, ByVal ReplayStopTime As Double, ByVal SamplesInReplay As System.Int32, _
        ByVal FrameNumber As System.Int32, ByRef AcquireDefinition As CSCOPE_ACQUIRE, ByRef GotSamples As Byte, _
        ByRef T0 As Double, ByRef dT As Double, ByRef NumSamples As System.UInt32, ByRef NumFrames As System.UInt32, _
        ByVal ChanAData() As Single, ByVal ChanAAllocSpace As System.UInt32, ByVal ChanBData() As Single, _
        ByVal ChanBAllocSpace As System.UInt32, ByVal DigitalInputData() As System.UInt16, _
        ByVal DigInpAllocSpace As System.UInt32, ByRef CAU_status As System.UInt16, ByRef errorOut As CSCOPE_ERROR)
    End Sub

    <DllImport("Cscope Control Driver.dll", CharSet:=CharSet.Auto)> _
    Public Shared Sub CscopeFunction(ByVal AcquisitionUnit As System.Int32, _
         ByVal FunctionCommand As System.UInt16, ByVal ByValParameter As Double, _
         ByVal LinkDataSend() As Byte, ByVal LinkDataSendAllocSpace As System.UInt32, _
         ByRef FunctionResult As Double, ByRef LinkDataReceived() As Byte, _
         ByVal LinkDataReceivedAllocSpace As System.UInt32, ByRef errorOut As CSCOPE_ERROR)
    End Sub


    <DllImport("Cscope Control Driver.dll", CharSet:=CharSet.Auto)> _
        Public Shared Function LVDLLStatus(ByVal errStr As String, _
        ByVal errStrLen As System.Int32, ByVal module_status As System.Int32) As System.Int32
    End Function
End Class

