Imports System.Text.RegularExpressions





Public Class cscope_intf

    'didn't use enum, because it requires a type conversion + huge verbosity

    Public Const c_init As UShort = 0
    Public Const c_acquire As UShort = 1
    Public Const c_replay As UShort = 2
    Public Const c_check As UShort = 3
    Public Const c_update As UShort = 4
    Public Const c_close As UShort = 5
    Public Const c_idle As UShort = 6
    Public Const c_function As UShort = 7
    Public Const c_get_frame As UShort = 8
    Public Const c_finish As UShort = 9

    Public Const acq_single As UShort = 0
    Public Const acq_auto As UShort = 1
    Public Const acq_triggered As UShort = 2
    Public Const acq_stop As UShort = 3

    Public Const c_runtime_closed As UShort = 0
    Public Const c_closed As UShort = 1
    Public Const c_open As UShort = 2
    Public Const c_fault As UShort = 3
    Public Const c_fault_closed As UShort = 4
    Public Const c_open_pending As UShort = 5

    Public Const trig_chan_a As UShort = 0
    Public Const trig_chan_b As UShort = 1
    Public Const trig_ext As UShort = 2
    Public Const trig_dig As UShort = 3

    Public Const if_usb As UShort = 0
    Public Const if_ethernet_find_ip As UShort = 1
    Public Const if_ethernet_first_ip As UShort = 2
    Public Const if_ethernet_find_sernum As UShort = 3

    Public Const max_samples As UInteger = 16384
    Public Const max_chars As UInteger = 1000
    Public Const t_divisions As UShort = 10
    Public Const v_divisions As UShort = 8

    Public v_div() As Double = {0.01, 0.02, 0.05, 0.1, 0.2, 0.5, 1, 2, 5}
    Public t_div() As Double = {1, 0.5, 0.2, 0.1, 0.05, 0.02, 0.01, 0.005, 0.002, 0.001, _
           0.0005, 0.0002, 0.0001, 0.00005, 0.00002, 0.00001, 0.000005, 0.000002, 0.000001, _
           0.0000005, 0.0000002, 0.0000001, 0.00000005, 0.00000002, 0.00000001}
    Public freqs() As Double = {1.0, 2, 5, 10, 20, 50, 100, 200, 500, 1000, 2000, 5000, 10000, _
            20000, 50000, 100000, 200000, 500000, 1000000, 2000000, 5000000}

    Public a_samples(max_samples) As Single 'contains the a channel samples
    Public b_samples(max_samples) As Single        'contains the b channel samples
    Public dig_samples(max_samples) As UShort 'contains teh digotal channel values

    Private scope_err As UInteger
    'result of scope error return
    Private samples_required As Integer
    'the number of samples to capture and display
    Private samples_returned As UInteger
    'actual number of samples returned
    Private dt As Double, t0 As Double     'holds time increment and start value
    Private frames_returned As UInteger
    'number of frames returned after sequential transfer
    Public acquire As CSCOPE_ACQUIRE              'holds the acquire definition
    Private scope_error As CSCOPE_ERROR                     'holds the error value
    Private got_samples As Byte
    'set to 1 when we have samples
    Private frame_number As Integer
    'frame number to extract for multi-frame replay
    Private CAU_status As UShort
    'gives status of CAU. 0 = Runtime Closed, 1 = Closed ,
    '2 = Open, 3 = Fault and open, 4 = Fault and Closed
    Private acquisition_unit As Integer
    'Acquisition unit we are talking to, 0..7
    Public tx_chars(max_chars) As Byte        'contains character array to send to link
    Public rx_chars(max_chars) As Byte     'contains character array received from link
    Private function_result As Double           'result of function call


    '***************************************************

public function call_cscope_control_driver(command as UShort) as Ushort
        'use this routine to call the control driver with a particular command
        Cscope_control.CscopeControlDriver(acquisition_unit, command, acquire.StartTime, acquire.StopTime, samples_required, frame_number, acquire, got_samples, _
                    t0, dt, samples_returned, frames_returned, a_samples, max_samples * 8, b_samples, max_samples * 8, _
                    dig_samples, max_samples * 2, CAU_status, scope_error)
        call_cscope_control_driver = CAU_status
    End Function

    Public Function get_function(ByVal cmd_value As UShort, ByVal cmd_parameter As Double) As Double
        'use this routine to call the control driver function command

        Cscope_control.CscopeFunction(acquisition_unit, cmd_value, cmd_parameter, _
         tx_chars, max_chars, function_result, rx_chars, max_chars, _
         scope_error)
        get_function = function_result
    End Function



    '**************************************************************
    Public Function scope_init() As UShort

        'Assumes the scope is connected and opens it.
        'Sets up the default values

        acquire.AcquireMode = 1     'automatic  (0 = single, 1 = automatic, 2 = triggered, 3 = stop)
        acquire.AcquisitionMode = 1 'peak captured
        acquire.Acquirer = 4           'cleverscope is the acquirer
        acquire.TransferChans = 2       'transfer both channels
        acquire.AMaxScale = 2           ' Volts range = +/-2
        acquire.AMinScale = -2
        acquire.BMaxScale = 2
        acquire.BMinScale = -2
        acquire.AProbe = 0              'x1
        acquire.BProbe = 0              'x1
        acquire.ACoupling = 1           'DC
        acquire.BCoupling = 1           'DC
        acquire.ABandwidth = 1          '100 MHz
        acquire.BBandwidth = 1          '100 MHz
        acquire.TriggerSource = 0       'A Chan trigger
        acquire.TriggerAmplitude = 0    'Trigger at zero volts
        acquire.ATriggerAmplitude = 0
        acquire.BTriggerAmplitude = 0
        acquire.TriggerFilter = 0       'No trigger filter
        acquire.TrigSlope = 0           'rising
        acquire.TriggerHoldoff = 0
        acquire.DigPatternRqd = 0       'not used
        acquire.DigPattern = 0     'not used
        acquire.ExtTrigThreshold = 0
        acquire.DigInputThreshold = 2
        acquire.StartTime = -0.005 '-5 msecs
        acquire.StopTime = 0.005      '5 msecs
        acquire.Port = 0
        acquire.NumDivisions = 10
        acquire.NumSeqFrames = 1
        acquire.NumBuffers = 2
        acquire.SigGenFreq = 1000       '1kHz output
        acquire.SigGenAmp = 1           '1V amplitude
        acquire.SigGenOffset = 0
        acquire.SigGenWaveform = 0      'sine
        acquire.SigGenSweep = 0
        acquire.SigGenFunc = 0
        acquire.SigGenFreq2 = 0
        acquire.SigGenPhase = 0
        acquire.Trig2Function = 0       'not used
        acquire.MinTriggerPeriod = 0.0000001
        acquire.MaxTriggerPeriod = 1
        acquire.TriggerCount = 1
        acquire.Trig2Slope = 0
        acquire.Trig2SourceChan = 0
        acquire.Trig2Level = 0
        acquire.DigPattern2Rqd = 0
        acquire.DigPattern2 = 0
        acquire.Trigger2Source = 0
        acquire.WaveformAverages = 1
        acquire.ValueChanged = 1
        acquire.SamplerResolution = 0   '0 = 10 bit (1 = 12 bit, 2 = 14 bit).
        samples_required = 1000
        acquire.IntfSource = 0          '0 = USB, 1 = Ethernet - open given IP address,
        '2 = Ethernet - open next free CAU, 3 = Ethernet - open  given Serial number
        acquire.TCPPort = 53270
        acquire.TCPAdr = 3232235880  '&HC0A80168
        acquire.CAUSerNumHi = 0
        acquire.CAUSerNumLo = 0
        acquire.UnitsAreLinked = 0
        acquire.ExtSampleClock = 0
        acquire.UpdateRate = 0
        acquire.TransferSize = 0

        frame_number = 0
        acquisition_unit = 0
        scope_init = call_cscope_control_driver(c_init)
        got_samples = False

    End Function

    '**************************************************
    Public Function cscope_interface(ByVal unit_index As Integer, ByVal Intf_source As UShort, ByVal TCP_adr As ULong) As UShort
        'Updates the interface spec. If the CAU_status indicates the scope is not open, attempts to open it.
        'Call this after changing the IP address etc.

        acquire.ValueChanged = acquire.ValueChanged + 1
        acquire.IntfSource = Intf_source
        acquire.TCPAdr = TCP_adr
        acquisition_unit = unit_index
        CAU_status = call_cscope_control_driver(c_idle)
        If (CAU_status <> c_open) Then
            cscope_interface = call_cscope_control_driver(c_init)
        Else
            cscope_interface = 0
        End If
    End Function



    '*************************************************
    Public Function scope_close() As UShort
        'closes the scope
        call_cscope_control_driver(c_close)
        scope_close = call_cscope_control_driver(c_finish)
    End Function


    '****************************************************
    Public Sub update_values(ByVal a_div As Double, ByVal b_div As Double, ByVal time_div As Double, ByVal number_of_points As Integer, _
    ByVal freq As Double, ByVal sigvolts As Double, ByVal trigvolts As Double, ByVal trig_chan As UInteger, ByVal trigger_action As UShort, ByVal dig_pattern As UInteger)
        'updates the acquire variable only. If triggered = 1 then we do triggered capture, otherwise auto capture
        acquire.AMaxScale = v_divisions * a_div / 2
        acquire.AMinScale = -acquire.AMaxScale
        acquire.BMaxScale = v_divisions * b_div / 2
        acquire.BMinScale = -acquire.BMaxScale
        acquire.StopTime = t_divisions * time_div / 2
        acquire.StartTime = -acquire.StopTime
        acquire.SigGenFreq = freq
        acquire.SigGenAmp = sigvolts
        acquire.TriggerAmplitude = trigvolts
        acquire.TriggerSource = trig_chan
        samples_required = number_of_points
        acquire.AcquireMode = trigger_action '0= auto, 1 = triggered, 3 = stop
        acquire.ValueChanged = acquire.ValueChanged + 1
        Select Case trig_chan
            Case trig_chan_a
                acquire.TriggerAmplitude = trigvolts
            Case trig_chan_b
                acquire.TriggerAmplitude = trigvolts
            Case trig_ext
                acquire.ExtTrigThreshold = trigvolts
            Case trig_dig
                acquire.DigInputThreshold = trigvolts
        End Select
        acquire.DigPattern = dig_pattern
    End Sub

    '*******************************************************
    Public Function scope_config() As UShort
        'Configures major values for the acquisition unit.
        scope_config = call_cscope_control_driver(c_update)
    End Function

    '*************************************************************************

    Public Function scope_acquire() As UShort
        'start an acquisition

        scope_acquire = call_cscope_control_driver(c_acquire)
    End Function

    '**************************************************************************
    Public Function scope_read_waveform(ByRef a_waveform() As Single, ByRef b_waveform() As Single, _
        ByRef num_samples As UInteger, ByRef delta_t As Double, ByRef t_zero As Double) As UShort
        'returns the last read waveform for the given channel
        Dim i As UInteger
        If samples_returned > 0 Then
            For i = 0 To samples_returned - 1
                a_waveform(i) = a_samples(i)
                b_waveform(i) = b_samples(i)
            Next
        End If
        delta_t = dt
        t_zero = t0
        num_samples = samples_returned
        scope_read_waveform = CAU_status
    End Function

    '**************************************************************************

    Public Function check_for_samples() As Boolean
        'checks to see if samples have been returned. If so returns 1, else 0

        call_cscope_control_driver(c_check)
        If got_samples Then
            got_samples = True
        End If
        check_for_samples = got_samples
    End Function

    '****************************************************************************

    Public Function get_CAU_status() As UShort
        'gets the current CAU status
        call_cscope_control_driver(c_idle)
        get_CAU_status = CAU_status
    End Function

    '****************************************************************************

    Public Function get_function(ByVal cmd_value As Integer) As Integer
        'executes the function, and returns the value. The value is passed in using frame_number, and returned in frames_returned. 
        frame_number = cmd_value
        call_cscope_control_driver(c_function)
        get_function = frames_returned
    End Function

    'Support routines



    '-------------------------------------------------------------------------
    '
    '   Public Function  eng(double value, Int32 digits) as string
    '
    '       Return String.Format("{0:G" + digits.ToString() + "}", value)
    '
    '


    '   Smallest power of then for which there is a prefix defined.
    '   If the set of prefixes will be extended, change this constant
    '   and update the table "prefix". */

    Public Function eng(ByVal value As Double, ByVal digits As Integer) As String

        Const PREFIX_START As Short = -24
        Const PREFIX_END As Short = 24
        Const prefix As String = "yzafpnum kMGTPEZY"

        Dim expof10 As Integer
        Dim negative As Boolean
        Dim estr As String = "                   "
        negative = False
        If (value < 0.0) Then
            value = -value
            negative = True
        End If

        If (value <> 0.0) Then
            expof10 = Math.Log10(value)
            If (expof10 > 0) Then
                expof10 = (expof10 \ 3) * 3
            Else
                expof10 = ((-expof10 + 3) \ 3) * (-3)
            End If
            value *= Math.Pow(10.0, -expof10)
            If (value >= 1000.0) Then
                value /= 1000.0
                expof10 += 3
            ElseIf (value >= 100.0) Then
                digits -= 2
            ElseIf (value >= 10.0) Then
                digits -= 1
            End If
        Else
            expof10 = 0 'no prefix
            digits = 3
        End If
        If ((expof10 >= PREFIX_START) And (expof10 <= PREFIX_END)) Then
            estr = String.Format("{0:f" + (digits - 1).ToString() + "}", value) + prefix((expof10 - PREFIX_START) / 3)
        End If
        If (negative) Then
            estr = "-" + estr
        End If
        eng = estr
    End Function

    Public Function string_to_IP(ByVal ip_string As String) As UInteger
        'converts the string pointed at by ip_str into an IP address,
        'assuming the format nnn.nnn.nnn.nnn
        '
        Dim ip_adr As UInteger
        Dim Tokens As String()

        ip_adr = 0
        Tokens = ip_string.Split(".")

        For Each Tok As String In Tokens
            If (Tok <> "") Then
                ip_adr = (ip_adr << 8) + UInteger.Parse(Tok)
            End If
        Next Tok
        string_to_IP = ip_adr
    End Function

End Class
