using System;
using	System.Runtime.InteropServices;

//********************************************************

[StructLayout (LayoutKind.Sequential,Pack=1)]
public struct CSCOPE_ACQUIRE
	{
	public	ushort AcquireMode;
	public	ushort AcquisitionMode;
	public	ushort Acquirer;
	public	ushort TransferChans;
	public	double AMaxScale;
	public	double AMinScale;
	public	double BMaxScale;
	public	double BMinScale;
	public	ushort AProbe;
	public	ushort BProbe;
	public	ushort ACoupling;
	public	ushort BCoupling;
	public	ushort ABandwidth;
	public	ushort BBandwidth;
	public	uint TriggerSource;
	public	double TriggerAmplitude;
	public	double ATriggerAmplitude;
	public	double BTriggerAmplitude;
	public	ushort TriggerFilter;
	public	byte TrigSlope;
	public	double TriggerHoldoff;
	public	byte DigPatternRqd;
	public	uint DigPattern;
	public	double ExtTrigThreshold;
	public	double DigInputThreshold;
	public	double StartTime;
	public	double StopTime;
	public	double SampleInterval;
	public	ushort Port;
	public	short NumDivisions;
	public	short NumSeqFrames;
	public	int NumBuffers;
	public	double SigGenFreq;
	public	double SigGenAmp;
	public	double SigGenOffset;
	public	ushort SigGenWaveform;
	public	ushort SigGenSweep;
	public	ushort SigGenFunc;
	public	double SigGenFreq2;
	public	double SigGenPhase;
	public	ushort Trig2Function;
	public	double MinTriggerPeriod;
	public	double MaxTriggerPeriod;
	public	uint TriggerCount;
	public	byte Trig2Slope;
	public	uint Trig2SourceChan;
	public	double Trig2Level;
	public	byte DigPattern2Rqd;
	public	uint DigPattern2;
	public	ushort Trigger2Source;
	public	int WaveformAverages;
	public	int ValueChanged;
	public	double FreqSpan;
	public	double FreqRes;
	public	double Duration;
	public	double Resolution;
	public	byte UnitsAreLinked;
	public	byte ExtSampleClock;
	public	byte FSpare2;
    public  byte FSpare3;
    public  byte FSpare4;
	public	ushort SamplerResolution;
	public	ushort IntfSource;
	public	ushort UpdateRate;
	public	ushort TransferSize;
	public	double SigGenFreqStep;
	public	uint TCPAdr;
	public	uint TCPPort;
	public  uint CAUSerNumHi;
	public  uint CAUSerNumLo;
	public  double FunctionNumber;
	public  double FunctionParameter;
	public  double FunctionResult;
	public  ulong LinkStart;
	public  ulong LinkTimebase;
	public  ulong LinkTimer;
	public  ulong LinkSetup;
	public  double Spare1;
	public  double Spare2;
	public  double Spare3;
	public  double Spare4;

	};



[StructLayout (LayoutKind.Sequential, Pack=1)]
    struct CSCOPE_ERROR
	{
	byte status;
	int code;
	int source; //this is normally a handle, but we aren't using it
	};


 //   public IntPtr module_ptr = IntPtr.Zero;

class Cscope_driver
{
    [DllImport("Cscope Control Driver.dll")]
    public static extern void CscopeControlDriver(
        int AcquisitionUnit, ushort Command,
        double ReplayStartTime, double ReplayStopTime, int SamplesInReplay,
        int FrameNumber, ref CSCOPE_ACQUIRE AcquireDefinition, ref byte GotSamples,
        ref double T0, ref double dT, ref uint NumSamples, ref uint NumFrames,
        float[] ChanAData, uint ChanAAllocSpace, float[] ChanBData,
        uint ChanBAllocSpace, ushort[] DigitalInputData,
        uint DigInpAllocSpace, ref ushort CAU_status, ref CSCOPE_ERROR errorOut);

    [DllImport("Cscope Control Driver.dll")]
    public  static  extern void CscopeFunction(int AcquisitionUnit, 
	ushort FunctionCommand, double Parameter, 
	byte [] LinkDataSend, uint LinkDataSendAllocSpace, 
	ref double FunctionResult, byte [] LinkDataReceived, 
	uint LinkDataReceivedAllocSpace, ref CSCOPE_ERROR errorOut);


    [DllImport("Cscope Control Driver.dll")]
    public static extern int LVDLLStatus(string errStr, int errStrLen, int module_status);
}
